package com.uas.plugins.maven.ops.diff.util;

import java.io.*;
import java.nio.charset.Charset;

/**
 * Created by Pro1 on 2017/6/15.
 */
public class StreamUtils {

    public static int copy(InputStream in, OutputStream out) throws IOException {
        assert null != in;
        assert  null != out;
        int byteCount = 0;
        byte[] buffer = new byte[4096];

        int bytesRead1;
        for(boolean bytesRead = true; (bytesRead1 = in.read(buffer)) != -1; byteCount += bytesRead1) {
            out.write(buffer, 0, bytesRead1);
        }

        out.flush();
        return byteCount;
    }

    public static String copyToString(InputStream in, Charset charset) throws IOException {
        assert null != in;
        StringBuilder out = new StringBuilder();
        InputStreamReader reader = new InputStreamReader(in, charset);
        char[] buffer = new char[4096];
        boolean bytesRead = true;

        int bytesRead1;
        while((bytesRead1 = reader.read(buffer)) != -1) {
            out.append(buffer, 0, bytesRead1);
        }

        return out.toString();
    }

    public static void copy(String in, Charset charset, OutputStream out) throws IOException {
        if (null != in) {
            assert null != charset;
            assert null != out;
            OutputStreamWriter writer = new OutputStreamWriter(out, charset);
            writer.write(in);
            writer.flush();
            writer.close();
        }
    }

}
